Ext.namespace("dSS", "dSS.config", "dSS.devprops");
dSS.devprops.VisibilityMatrix = {
    'GE' :  {
                'KM:2'      :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : true
                               },
                'TKM:2'     :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : true
                               },
                'SDM:2'     :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : true
                                },
                'KL'        :   {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : false,
                                    'outmode'       : false,
                                    'pushbutton'    : true,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : true
                                }
            },
    'GN' :  {
                'KM:2'       :   {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : false,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : false
                                },
                'TKM:2'      :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : false,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : false
                                }
            },
    'RT' :  {
                'TKM:2'      :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : false,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : false,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : false
                                },
                'SDM:2'      :  {
                                    'dontcare'      : true,
                                    'blink'         : true,
                                    'led'           : true,
                                    'transt'        : true,
                                    'outmode'       : true,
                                    'pushbutton'    : false,
                                    'threshold'     : true,
                                    'scenetranst'   : true,
                                    'limitedpushbf' : false
                                }
            }
};

dSS.devprops.GetVisibleProperties = function(devClass, devType, devNumber) {
    var none = {
                   'dontcare'      : false,
                   'blink'         : false,
                   'led'           : false,
                   'transt'        : false,
                   'outmode'       : false,
                   'pushbutton'    : false,
                   'threshold'     : false,
                   'scenetranst'   : false,
                   'limitedpushbf' : false
               };

    var dc = dSS.devprops.VisibilityMatrix[dSS.config.deviceColors[devClass]];
    if (dc === undefined) {
        throw none;
    }

    var key = dSS.config.deviceTypes[devType];
    if (key !== 'KL') {
        if (devNumber >= 200) {
            devNumber = String(devNumber).charAt(0);
        }
        key = key + ':' + devNumber;
    }

    var ret = dc[key];
    if (ret === undefined) {
        throw none;
    } else {
        return ret;
    }
};

